# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team

$|=1; # line buffering

$version = '0.9.9';
$revision = 'final-p1';
$swroot = '/var/smoothwall';
$pagecolour = '#ffffff';
$tablecolour = '#a0a0a0';
$bigboxcolour = '#6e6e6e';
$boxcolour = '#808080';
$bordercolour = '#000000';
$table1colour = '#a0a0a0';
$table2colour = '#606060';
$colourred = '#b03030';
$colourorange = '#b0b030';
$colourgreen = '#30b030';
$viewsize = 50 ;

&readhash("${swroot}/main/settings", \%settings);
$language = $settings{'LANGUAGE'};

if ($language =~ /^(\w+)$/) {$language = $1;}
require "${swroot}/langs/base.pl";
require "${swroot}/langs/${language}.pl";

sub showhttpheaders
{
	print "Pragma: no-cache\n";
	print "Cache-control: no-cache\n";
	print "Connection: close\n";
	print "Content-type: text/html\n\n";
}

sub showmenu
{
	print <<END
<TD WIDTH='135' VALIGN='top' BGCOLOR='$bigboxcolour'>

<A HREF='/cgi-bin/index.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('home','','/images/home_side_over.gif');"><IMG
SRC='/images/home_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt home'}' NAME='home'></A><BR>

<A HREF='/cgi-bin/status.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('information','','/images/information_side_over.gif');"><IMG
SRC='/images/information_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt information'}' NAME='information'></A><BR>

<A HREF='/cgi-bin/pppsetup.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('dialup','','/images/dialup_side_over.gif');"><IMG
SRC='/images/dialup_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt dialup'}' NAME='dialup'></A><BR>

<A HREF='/cgi-bin/remote.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('ras','','/images/ras_side_over.gif');"><IMG
SRC='/images/ras_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt remote access'}' NAME='ras'></A><BR>

<A HREF='/cgi-bin/proxy.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('services','','/images/services_side_over.gif');"><IMG
SRC='/images/services_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt services'}' NAME='services'></A><BR>

<A HREF='/cgi-bin/ids.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('ids','','/images/ids_side_over.gif');"><IMG
SRC='/images/ids_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt ids'}' NAME='ids'></A><BR>

<A HREF='/cgi-bin/vpnmain.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('vpn','','/images/vpn_side_over.gif');"><IMG
SRC='/images/vpn_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt vpn'}' NAME='vpn'></A><BR>

<A HREF='/cgi-bin/logs.cgi/log.dat' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('logs','','/images/logs_side_over.gif');"><IMG
SRC='/images/logs_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt logs'}' NAME='logs'></A><BR>

<A HREF='/cgi-bin/shutdown.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('shutdown','','/images/shutdown_side_over.gif');"><IMG
SRC='/images/shutdown_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt shutdown'}' NAME='shutdown'></A><BR>

<A HREF='/cgi-bin/shell.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('shell','','/images/shell_side_over.gif');"><IMG
SRC='/images/shell_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt shell'}' NAME='shell'></A><BR>

<A HREF='/cgi-bin/updates.cgi' onMouseOut="javascript:MM_swapImgRestore();"
onMouseOver="javascript:MM_swapImage('updates','','/images/updates_side_over.gif');"><IMG
SRC='/images/updates_side.gif' WIDTH='135' HEIGHT='22' BORDER='0' ALT='$tr{'alt updates'}' NAME='updates'></A><BR>

<P>

<A HREF='/cgi-bin/credits.cgi'><IMG SRC='/images/swlogo.gif' BORDER='0'></A>

</TD>
END
	;
}

sub subsectionstart
{
	print <<END
<DIV ALIGN='LEFT'>
<TABLE BGCOLOR='$bigboxcolour' BORDER='0' CELLPADDING='0' CELLSPACING='0'>
<TR>
<TD ALIGN='LEFT' VALIGN='TOP' HEIGHT='18'><IMG SRC='/images/corner1.gif'></TD>
<TD VALIGN='MIDDLE' HEIGHT='18'>
END
	;
}

sub subsectionend
{
	print <<END
</TD><TD ALIGN='RIGHT' VALIGN='TOP' HEIGHT='18'><IMG SRC='/images/corner2.gif'></TD></TR>
</TABLE>
</DIV>
END
	;
}

sub subsectiontab
{
	$href = $_[0];
	$linktext = $_[1];
	$end = $_[2];
	$scriptname = $ENV{'SCRIPT_NAME'};

	$basehref = $href;
	$basehref =~ s/\?.*$//g;

	if ($scriptname eq $basehref) {
		print "<B><FONT COLOR='#a0a0e0'>$linktext</FONT></B>"; }
	else {
		print "<A HREF='$href'>$linktext</A>"; }
	if ($end eq '0') {
		print ' | '; }
}	

sub showhomesection
{
        &subsectionstart();
	&subsectiontab('/cgi-bin/index.cgi', $tr{'sshome'}, 0);
	&subsectiontab('/cgi-bin/help.cgi?home', $tr{'sshelp'}, 1);
        &subsectionend();
}

sub showinformationsection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/status.cgi', $tr{'ssstatus'}, 0);
        &subsectiontab('/cgi-bin/graphs.cgi', $tr{'sstraffic graphs'}, 0);
	&subsectiontab('/cgi-bin/help.cgi?information', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showdialupsection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/pppsetup.cgi', $tr{'ssppp settings'}, 0);
	&subsectiontab('/cgi-bin/usbadslfw.cgi', $tr{'ssusb adsl firmware upload'}, 0);
	&subsectiontab('/cgi-bin/modem.cgi', $tr{'ssmodem'}, 0);
	&subsectiontab('/cgi-bin/help.cgi?dialup', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showrassection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/remote.cgi', $tr{'ssssh'}, 0);
	&subsectiontab('/cgi-bin/changepw.cgi', $tr{'sspasswords'}, 0);
 	&subsectiontab('/cgi-bin/help.cgi?ras', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showservicessection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/proxy.cgi', $tr{'ssweb proxy'}, 0);
	&subsectiontab('/cgi-bin/dhcp.cgi', $tr{'ssdhcp'}, 0);
	&subsectiontab('/cgi-bin/portfw.cgi', $tr{'ssport forwarding'}, 0);
	&subsectiontab('/cgi-bin/xtaccess.cgi', $tr{'ssexternal service access'}, 0);
	&subsectiontab('/cgi-bin/dmzholes.cgi', $tr{'ssdmz pinholes'}, 1);
	print "<BR>\n";
	&subsectiontab('/cgi-bin/listgreens.cgi', $tr{'list gnets'}, 0);
	&subsectiontab('/cgi-bin/ddns.cgi', $tr{'ssdynamic dns'}, 0);
 	&subsectiontab('/cgi-bin/help.cgi?services', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showidssection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/ids.cgi', $tr{'ssids'}, 0);
	&subsectiontab('/cgi-bin/help.cgi?ids', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showvpnsection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/vpnmain.cgi', $tr{'sscontrol'}, 0);
	&subsectiontab('/cgi-bin/vpn.cgi/vpnconfig.dat', $tr{'ssconnections'}, 0);
 	&subsectiontab('/cgi-bin/help.cgi?vpn', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showlogssection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/logs.cgi/log.dat', $tr{'ssother'}, 0);
	&subsectiontab('/cgi-bin/logs.cgi/proxylog.dat', $tr{'ssweb proxy'}, 0);
	&subsectiontab('/cgi-bin/logs.cgi/firewalllog.dat', $tr{'ssfirewall'}, 0);
	&subsectiontab('/cgi-bin/logs.cgi/ids.dat', $tr{'ssids'}, 0);
 	&subsectiontab('/cgi-bin/help.cgi?logs', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showshutdownsection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/shutdown.cgi', $tr{'ssshutdown'}, 0);
 	&subsectiontab('/cgi-bin/help.cgi?shutdown', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showshellsection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/shell.cgi', $tr{'ssshell'}, 0);
 	&subsectiontab('/cgi-bin/help.cgi?shell', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showupdatessection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/updates.cgi', $tr{'ssupdates'}, 0);
	&subsectiontab('/cgi-bin/help.cgi?updates', $tr{'sshelp'}, 1);
	&subsectionend();
}

sub showcreditssection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/credits.cgi', $tr{'sscredits'}, 1);
	&subsectionend();
}

sub showipinfosection
{
	&subsectionstart();
	&subsectiontab('/cgi-bin/ipinfo.cgi', $tr{'ssip info'}, 1);
	&subsectionend();
}

sub openpage
{
	$title = $_[0];
	$menu = $_[1];
	$extrahead = $_[2];

	if ($menu == 1) { $colspan = 2; } else { $colspan = 1; }

	print <<END
<HTML>
<HEAD>
$extrahead
<TITLE>SmoothWall - $title</TITLE>
<SCRIPT LANGUAGE='javascript' SRC='/jscript.js'></SCRIPT>
<LINK HREF='/style100.css' REL='STYLESHEET' TYPE='text/css'>
</HEAD>
<BODY BGCOLOR='$pagecolour' TEXT='#ffffff' LINK='#ffffff' VLINK='#404040'>
<DIV ALIGN='CENTER'>
<TABLE WIDTH='760' BORDER='0' BGCOLOR='$tablecolour' CELLPADDING='0' CELLSPACING='0'>
<TR><TD COLSPAN='$colspan' WIDTH='760'>
<IMG SRC='/images/title.gif' WIDTH='760' HEIGHT='80' BORDER='0' ALT=''></TD>
</TR><TR>

END
	;
	if ($menu == 1) {
		&showmenu(); }

	print <<END
<TD ALIGN='CENTER' VALIGN='TOP'>
<TABLE WIDTH='625' CELLPADDING='10'>
<TR>
<TD>
END
	;
}

sub closepage
{
	print <<END
<DIV ALIGN='RIGHT'>
<TABLE BGCOLOR='$bigboxcolour' BORDER='0' CELLPADDING='0' CELLSPACING='0'>
<TR><TD WIDTH=10 ALIGN=LEFT VALIGN=BOTTOM HEIGHT=18><IMG SRC="/images/corner.gif"></TD><TD VALIGN=TOP HEIGHT=18>
<A HREF='http://www.smoothwall.org'>smoothwall.org</A>
- $tr{'powered by'} <A HREF='http://www.highspeedweb.net'>Genesis II Networks LLC</A>
</TD><TD WIDTH='10' ALIGN='RIGHT' VALIGN='BOTTOM' HEIGHT='18'><IMG SRC='/images/corner3.gif'></TD></TR>
</TABLE>
</TD>
</TR>
</TABLE>
</TD>
</TR>
</TABLE>
</DIV>
</BODY>
</HTML>
END
	;
}

sub openbigbox
{
	$width = $_[0];
	$align = $_[1];

	print <<END
<TABLE WIDTH='$width' CELLSPACING='0' CELLPADDING='0' BORDER='0'>
<TR>
<TD BGCOLOR='$bigboxcolour' WIDTH='10' HEIGHT='10' ALIGN='LEFT' VALIGN='TOP'>&nbsp;</TD>
<TD BGCOLOR='$bigboxcolour' HEIGHT='10'>&nbsp;</TD>
<TD BGCOLOR='$bigboxcolour' WIDTH='10' HEIGHT='10' ALIGN='RIGHT' VALIGN='TOP'>
<IMG SRC='/images/corner2.gif'></TD>
</TR>
<TR>
<TD WIDTH='10' BGCOLOR='$bigboxcolour'>&nbsp;</TD>
<TD BGCOLOR='$bigboxcolour' ALIGN='$align'>
END
	;
}

sub closebigbox
{
	print <<END
</TD><TD WIDTH='10' BGCOLOR='$bigboxcolour'>&nbsp;</TD></TR>
<TR>
<TD WIDTH='10' BGCOLOR='$bigboxcolour' HEIGHT='10' ALIGN='LEFT' VALIGN='BOTTOM'><IMG SRC="/images/corner.gif"></TD>
<TD BGCOLOR='$bigboxcolour' HEIGHT='10'>&nbsp;</TD>
<TD WIDTH='10' HEIGHT='10' BGCOLOR='$bigboxcolour'>&nbsp;</TD>
</TR>
</TABLE>
END
	;
}

sub openbox
{
	$width = $_[0];
	$align = $_[1];
	$caption = $_[2];

	if ($caption) { print "<B><DIV CLASS='boldbase'>$caption</DIV></B>\n"; }
	print <<END
<TABLE WIDTH='$width'>
<TR><TD BGCOLOR='$boxcolour' ALIGN='$align'>
END
	;
}

sub closebox
{
	print <<END
</TD></TR>
</TABLE>
<BR>
END
	;
}

sub writehash
{
	my $filename = $_[0];
	my $hash = $_[1];
	
	# write cgi vars to the file.
	open(FILE, ">${filename}") or die "Unable to write file $filename";
	flock FILE, 2;
	foreach $var (keys %$hash) 
	{
		$val = $hash->{$var};
		if ($val =~ / /) {
			$val = "\'$val\'"; }
		if (!($var =~ /^ACTION/)) {
			print FILE "${var}=${val}\n"; }
	}
	close FILE;
}

sub readhash
{
	my $filename = $_[0];
	my $hash = $_[1];
	my ($var, $val);

	open(FILE, $filename) or die "Unable to read file $filename";
	
	while (<FILE>)
	{
		chop;
		($var, $val) = split /=/, $_, 2;
		if ($var)
		{
			$val =~ s/^\'//g;
			$val =~ s/\'$//g;
			$hash->{$var} = $val;
		}
	}
	close FILE;
}

sub getcgihash
{
	my $hash = $_[0];
	my $buffer = '';
	my $length = $ENV{'CONTENT_LENGTH'};
	my ($name, $value); 
	my ($pair, @pairs, $read);
	my %hash;
	my $boundary;
	
	if ($ENV{'REQUEST_METHOD'} ne 'POST') {
		return; }
	
	$read = 0;
	$buffer = "";
	while($read < $length){
		$read = $read + (read(STDIN, $buf, 1024) or die "Could not read buffer:$read: $@");
		$buffer .= $buf;
	}
	unless($read == $length) {
		die "Could not read buffer: $!";
	}

	if($ENV{'CONTENT_TYPE'} =~ m/multipart\/form-data; boundary=(.*)/) {
		$boundary = $1;
		chomp $boundary;
		$boundary =~ s/\+/ /g;
		foreach (split(/$boundary/,$buffer)) {
			s!--$!!so;
			if(m/Content-Disposition: form-data; name="(.*?)"/is) {
				$name = $1;
			}
			if(m/Content-Disposition: form-data; name="$name".*?\015\012\015\012(.*)$/is) {
				$value = $1;
				$value =~ s!\015\012$!!so;
				$hash->{$name} = $value;
			}
			else { next; }
		}
	} else {
		@pairs = split(/&/, $buffer);

		foreach $pair (@pairs)
		{
			$pair =~ s/\+/ /g;
			($name, $value) = split(/=/, $pair);
			next unless $name; # fields MUST BE named!
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
			$value =~s/[^\w\013\n!@#\$%\^\*()_\-\+=\{\}\[\]\\|;:\'\"<,>\.?\/`~\& ]//g;
			$hash->{$name} = $value;
    		}
    	}
	return %hash;
}

sub log
{
	system('/usr/bin/logger', '-t', 'smoothwall', $_[0]);
}

sub age
{
	my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
	        $atime, $mtime, $ctime, $blksize, $blocks) = stat $_[0];
	my $now = time;

	my $totalsecs = $now - $mtime;
	my $days = int($totalsecs / 86400);
	my $totalhours = int($totalsecs / 3600);
	my $hours = $totalhours % 24;
	my $totalmins = int($totalsecs / 60);
	my $mins = $totalmins % 60;
	my $secs = $totalsecs % 60;

 	return "${days}d ${hours}h ${mins}m ${secs}s";
}

sub validip
{
	my $ip = $_[0];

	if (!($ip =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)) {
		return 0; }
	else 
	{
		@octets = ($1, $2, $3, $4);
		foreach $_ (@octets)
		{
			if (/^0./) {
				return 0; }
			if ($_ < 0 || $_ > 255) {
				return 0; }
		}
		return 1;
	}
}

sub validmask
{
	my $mask = $_[0];

	# secord part an ip?
	if (&validip($mask)) {
		return 1; }
	# second part a number?
	if (/^0/) {
		return 0; }
	if (!($mask =~ /^\d+$/)) {
		return 0; }
	if ($mask >= 0 && $mask <= 31) {
		return 1; }
	return 0;
}

sub validipormask
{
	my $ipormask = $_[0];

	# see if it is a IP only.
	if (&validip($ipormask)) {
		return 1; }
	# split it into number and mask.
	if (!($ipormask =~ /^(.*?)\/(.*?)$/)) {
		return 0; }
	$ip = $1;
	$mask = $2;
	# first part not a ip?
	if (!(&validip($ip))) {
		return 0; }
	return &validmask($mask);
}

sub validipandmask
{
	my $ipandmask = $_[0];

	# split it into number and mask.
	if (!($ipandmask =~ /^(.*?)\/(.*?)$/)) {
		return 0; }
	$ip = $1;
	$mask = $2;
	# first part not a ip?
	if (!(&validip($ip))) {
		return 0; }
	return &validmask($mask);
}

sub validport
{
	$_ = $_[0];

	if (!/^\d+$/) {
		return 0; }
	if (/^0./) {
		return 0; }
	if ($_ >= 1 && $_ <= 65535) {
		return 1; }
	return 0;
}
